program Ryesap;

//------------------------------------------------------------------------------
// About Ryesap...
//
// author         :  MinMin
// version        :  build 0.0.3
// date           :  Mar, 2004 (since 2002)
// copyright      :  Copyright (C) 2002-2004 MinMin.
// e-mail         :  nmnljam@yahoo.co.jp
// redistribution :  This program is distributed under the GPL. see below.
//------------------------------------------------------------------------------
// About StripReloc...
//
//   This program is FREEWARE;
//   you may redistibute it and/or modify it freely.
//   In case of redistribution, I hope you will write above copyright
//   in addition.
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//------------------------------------------------------------------------------

uses
  Windows,
  Messages,
  ShlObj,
  CommDlg,
  ShellAPI,
  ActiveX,
  RyesapUtils,
  StripReloc;

resourcestring

  CRLF = #13#10;
  RyesapDescription = 'Ryesap build 0.0.3';
  RyesapCopy        = 'Copyright (C) 2002-2004 MinMin.'+#13#10+
    'mailto: nmnljam@yahoo.co.jp';
  StripRelocVersion = 'Powered by StripReloc v1.12'+#13#10+
    'Copyright (C) 1999-2004 Jordan Russell, www.jrsoftware.org'+#13#10+
    'This Program is FREEWARE under the terms of the GNU General Public License.   ';

  // Caption Resources
  RESSTR_J_ADDFILES  = 't@Cǉ(&F)';
  RESSTR_J_ADDFOLDER = 'tH_ǉ(&D)';
  RESSTR_J_REMOVE    = 'Xg폜(&R)';
  RESSTR_J_CHECK1    = 'obNAbvt@C쐬Ȃ(&B)';
  RESSTR_J_CHECK2    = 'wb_Ƀ`FbNT(&W)';
  RESSTR_J_CHECK3    = 'DLL(܂)';
  RESSTR_J_START     = 'Jn(&S)';
  RESSTR_J_ABOUT     = 'Ryesapɂ(&A)';
  RESSTR_J_EXIT      = 'I(&X)';
  RESSTR_J_REMOVEMSG = 'IꂽACe폜܂.';
  RESSTR_J_REMOVECAP = '폜';
  RESSTR_J_SELDIR    = 'tH_Iĉ';
  RESSTR_J_PRGCLOSE  = '(&C)';

  RESSTR_E_ADDFILES  = 'Add &Files...';
  RESSTR_E_ADDFOLDER = 'Add &Fol&der...';
  RESSTR_E_REMOVE    = '&Remove from List';
  RESSTR_E_CHECK1    = 'Don''t create .bak backup files(&B)';
  RESSTR_E_CHECK2    = 'Write a valid checksum in the header instead of zero(&W)';
  RESSTR_E_CHECK3    = 'Force stripping DLLs instead of skipping them. (DON''T USE!)';
  RESSTR_E_START     = '&Start';
  RESSTR_E_ABOUT     = '&About';
  RESSTR_E_EXIT      = 'E&xit';
  RESSTR_E_REMOVEMSG = 'Are you sure to remove selected items?';
  RESSTR_E_REMOVECAP = 'Remove';
  RESSTR_E_SELDIR    = 'Select Directory';
  RESSTR_E_PRGCLOSE  = '&Close';

  // addtional system menu item for changing language
  RESSTR_CHANGELANG  = '&Japanese';

const

 // Resource IDs
 IDD_DIALOG             =   114;
 IDD_DIALOG_PROGRESS    =   115;
 IDD_DIALOG_ABOUT       =   116;
 IDC_LISTBOX            =  1063;
 IDC_BUTTON_ADDFILES    =  1064;
 IDC_BUTTON_ADDFOLDER   =  1065;
 IDC_BUTTON_REMOVE      =  1066;
 IDC_OPTION             =  1067;
 IDC_CHECK_STRIP1       =  1068;
 IDC_CHECK_STRIP2       =  1069;
 IDC_CHECK_STRIP3       =  1070;
 IDC_EDIT_PROGRESS      =  1074;
 IDABOUT                =     3;
 IDSTART                =  1076;
 IDEXIT                 =  1077;
 IDM_CHANGELANG         =  1090;
 IDC_BUTTON_CLOSE       =  1081;

var

  // Window Handle
  // main dialog
  hMainWindow  : HWND;
  // file listbox
  hFileListBox : HWND;
  // don't create backup
  hCheckBox1   : HWND;
  // write checksum
  hCheckBox2   : HWND;
  // force dll
  hCheckBox3   : HWND;
  // strip process dialog
  hProgressWindow: HWND = 0;

  bUseJapanese : boolean = false;
  bProcessDone: boolean;

{$R Ryesap.res}
{$R RyesapRes.res}


{==============================================================================}

function IsCheckedForCB(hCheckBox: HWND): boolean;
begin
  Result := (SendMessage(hCheckBox, BM_GETCHECK, 0, 0) = BST_CHECKED);
end;

{==============================================================================}

// set the dropped files on file listbox
procedure CheckDroppedFiles(hDrop: THandle);
var
  i: integer;
  nFileCount: UINT;
  nFileNameLength : UINT;
  lpFileName: array[0..MAX_PATH-1] of Char;
  nDllEnabled: integer;
begin
  nDllEnabled := SendMessage(hCheckBox3, BM_GETCHECK, 0, 0);
  try
    nFileCount := DragQueryFile(hDrop, $ffffffff, nil, 0);
    if nFileCount > 0 then
    begin
      for i:=0 to nFileCount-1 do
      begin
        nFileNameLength := DragQueryFile(hDrop, i, nil, 0);
        FillChar(lpFileName, MAX_PATH, 0);
        DragQueryFile(hDrop, i, lpFileName, nFileNameLength+1);
        if IsPEFileExt(lpFileName, (nDllEnabled = BST_CHECKED)) then
          AddStringToListBox(hFileListBox, lpFileName);
      end;
    end;
  finally
    DragFinish(hDrop); 
  end;
end;

{==============================================================================}

// callback for "select folder dialog"
function BrowseCallbackProc(hWindow: HWND; uMsg: UINT;
  lParam: LPARAM; lpData: LPARAM): integer; stdcall;
begin
  Result := 0;
  case uMsg of
    BFFM_INITIALIZED:
      begin
        SendMessage(hWindow, BFFM_SETSELECTION, WPARAM(true), lpData); 
      end;
  end;
end;

// show "select folder dialog"
procedure ShowSelectFolderDialog(hWindow: HWND);
var
  BrowseInfo: TBrowseInfo;
  ItemIDList: PItemIDList;
  pBuffer: array[0..MAX_PATH-1] of Char;
  Malloc: IMalloc;
begin
  FillChar(pBuffer, SizeOf(pBuffer), 0);
  FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
  if (SHGetMalloc(Malloc) = S_OK) and (Malloc <> nil) then begin
    with BrowseInfo do begin
      pidlRoot  := nil;
      pszDisplayName := pBuffer;
      if bUseJapanese then
        lpszTitle := PChar(RESSTR_J_SELDIR)
      else
        lpszTitle := PChar(RESSTR_E_SELDIR);
      ulFlags   := BIF_RETURNONLYFSDIRS;
      lpfn      := @BrowseCallbackProc;
      hwndOwner := hWindow;
      lParam    := 0;
      iImage    := 0;
    end;
    ItemIDList := SHBrowseForFolder(BrowseInfo);
    if ItemIDList = nil then
    begin
      Exit;
    end
    else begin
      try
        SHGetPathFromIDList(ItemIDList, pBuffer);
        GetFilesOnDir(hFileListBox, pBuffer,
          (SendMessage(hCheckBox3, BM_GETCHECK, 0, 0) = BST_CHECKED));
      finally
        Malloc.Free(ItemIDList);
      end;
    end;
  end;
end;

{==============================================================================}

// show open files dialog and get filename
procedure GetOpenFileDlg(hWindow: HWND);
var
  OSVersionInfo: TOSVersionInfo;
  Win32Platform,
  Win32MajorVersion,
  Win32MinorVersion: integer;
  ofn     : TOpenFilename;
  pBuffer : array[0..MAX_PATH+4] of Char;
  ret     : LongBool;
  reterr  : Cardinal;
  DllEnabled: integer;
begin
  reterr := 0;
  with OSVersionInfo do
  begin
    Win32Platform     := 0;
    Win32MajorVersion := 0;
    Win32MinorVersion := 0;
    dwOSVersionInfoSize := SizeOf(OSVersionInfo);
    if GetVersionEx(OSVersionInfo) then
    begin
      with OSVersionInfo do
      begin
        Win32Platform     := dwPlatformId;
        Win32MajorVersion := dwMajorVersion;
        Win32MinorVersion := dwMinorVersion;
      end;
    end;
  end;
  FillChar(pBuffer, SizeOf(pBuffer), 0);
  FillChar(ofn, SizeOf(TOpenFilename), 0);
  // Win2k and WinMe
  if ((Win32MajorVersion >= 5) and
      (Win32Platform = VER_PLATFORM_WIN32_NT)) or
     ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and
      (Win32MajorVersion >= 4) and
      (Win32MinorVersion >= 90))
  then
    ofn.lStructSize := SizeOf(TOpenFilename)
  else
    ofn.lStructSize := SizeOf(TOpenFilename) -
      (SizeOf(DWORD) shl 1) - SizeOf(Pointer);
  ofn.hWndOwner   := hWindow;
  ofn.hInstance   := SysInit.HInstance;
  ofn.lpstrFilter := 'exe,dllfiles(*.exe,*.dll)'#0'*.exe;*.dll'#0#0;
  ofn.nFilterIndex := 1;
  ofn.lpstrTitle  := 'Open Exe/Dll File';
  ofn.lpstrFile   := pBuffer;
  ofn.nMaxFile    := MAX_PATH+4;
  ofn.Flags       := OFN_FILEMUSTEXIST or OFN_HIDEREADONLY;
  ret := GetOpenFileName(ofn);
  if ret then
  begin
    DllEnabled := SendMessage(hCheckBox3, BM_GETCHECK, 0, 0);
    if IsPEFileExt(pBuffer, (DllEnabled = BST_CHECKED)) then
      AddStringToListBox(hFileListBox, pBuffer)
  end
  else
    reterr := CommDlgExtendedError;
end;

{==============================================================================}

// remove selected entries from file listbox
procedure RemoveFiles(hWindow: HWND);
var
  nItemCount: integer;
  strMsg, strCap: string;
begin
  nItemCount := SendMessage(hFileListBox, LB_GETSELCOUNT , 0, 0);
  if (nItemCount <= 0) or (nItemCount = LB_ERR) then
    Exit;
  if bUseJapanese then
  begin
    strMsg := RESSTR_J_REMOVEMSG;
    strCap := RESSTR_J_REMOVECAP;
  end
  else
  begin
    strMsg := RESSTR_E_REMOVEMSG;
    strCap := RESSTR_E_REMOVECAP;
  end;
  if MessageBox(hWindow,
      PChar(strMsg),
      PChar(strCap),
      MB_YESNO or MB_ICONQUESTION) = IDYES then
    RemoveFilesFromListBox(hFileListBox);
end;

{==============================================================================}

procedure SendStripProcess;
var
  i: integer;
  nItemCount: integer;
  strResult: string;
  szFileName: array[0..MAX_PATH-1] of char;
  bKeepBackups: boolean;
  bWantValidChecksum: boolean;
  bForceStrip: boolean;
  hEdit: HWND;
begin
  nItemCount := SendMessage(hFileListBox, LB_GETCOUNT, 0, 0);
  if nItemCount > 0 then
  begin
    for i:=0 to nItemCount-1 do
    begin
      FillChar(szFileName, MAX_PATH, 0);
      if SendMessage(hFileListBox, LB_GETTEXT, i, LPARAM(@szFileName)) > 0 then
      begin
        bKeepBackups       := not IsCheckedForCB(hCheckBox1);
        bWantValidChecksum := IsCheckedForCB(hCheckBox2);
        bForceStrip        := IsCheckedForCB(hCheckBox3);
        strResult := ProcessStrip(szFileName, bUseJapanese,
          bKeepBackups, bWantValidChecksum, bForceStrip);
        hEdit := GetDlgItem(hProgressWindow, IDC_EDIT_PROGRESS);
        SendMessage(hEdit, EM_REPLACESEL, 0, LPARAM(PChar(strResult)));
      end;
    end;
  end;
end;

{==============================================================================}

function ProgWndProc(
  hWindow: HWND;
  uMsg: UINT;
  wParam: WPARAM;
  lParam: LPARAM): LRESULT; stdcall;
var
  wTargetID: Word;
begin
  result := LRESULT(true);
  case uMsg of
    WM_INITDIALOG:
    begin
      if bUseJapanese then
      begin
        SetDlgItemText(hWindow, IDC_BUTTON_CLOSE, PChar(RESSTR_J_PRGCLOSE));
        SetWindowText(hProgressWindow, PChar(RESSTR_J_PROCESSING));
      end
      else
      begin
        SetDlgItemText(hWindow, IDC_BUTTON_CLOSE, PChar(RESSTR_E_PRGCLOSE));
        SetWindowText(hProgressWindow, PChar(RESSTR_E_PROCESSING));
      end;
    end;
    WM_CLOSE:
      begin
        hProgressWindow := 0;
        EndDialog(hWindow, 0);
      end;
    WM_COMMAND:
      case HiWord(wParam) of
        BN_CLICKED:
        begin
          wTargetID := LoWord(wParam);
          case wTargetID of
            IDC_BUTTON_CLOSE:
              begin
                hProgressWindow := 0;
                EndDialog(hWindow, 0);
              end;
          end;
        end;
      end;
  else
    Result := LRESULT(false);
  end;
end;

procedure ProcessFiles(hWindow: HWND);
var
  nItemCount: integer;
begin
  if hProgressWindow <> 0 then
    Exit;
  nItemCount := SendMessage(hFileListBox, LB_GETCOUNT, 0, 0);
  if nItemCount <= 0 then
    Exit;
  bProcessDone := false;
  InitResourceString(bUseJapanese);
  hProgressWindow := CreateDialogParam(
    HInstance,
    MAKEINTRESOURCE(IDD_DIALOG_PROGRESS),
    hWindow,
    @ProgWndProc,
    0);
  ShowWindow(hProgressWindow, SW_SHOW);
  EnableWindow(GetDlgItem(hProgressWindow, IDC_BUTTON_CLOSE), false);
  try
    SendStripProcess;
  finally
    EnableWindow(GetDlgItem(hProgressWindow, IDC_BUTTON_CLOSE), true);
  end;
end;

{==============================================================================}

// set captions
procedure SetControlText(hWindow: HWND);
begin
  if bUseJapanese then
  begin
    SetDlgItemText(hWindow, IDC_BUTTON_ADDFILES,  PChar(RESSTR_J_ADDFILES));
    SetDlgItemText(hWindow, IDC_BUTTON_ADDFOLDER, PChar(RESSTR_J_ADDFOLDER));
    SetDlgItemText(hWindow, IDC_BUTTON_REMOVE,    PChar(RESSTR_J_REMOVE));
    SetWindowText(hCheckBox1, PChar(RESSTR_J_CHECK1));
    SetWindowText(hCheckBox2, PChar(RESSTR_J_CHECK2));
    SetWindowText(hCheckBox3, PChar(RESSTR_J_CHECK3));
    SetDlgItemText(hWindow, IDSTART,  PChar(RESSTR_J_START));
    SetDlgItemText(hWindow, IDABOUT,  PChar(RESSTR_J_ABOUT));
    SetDlgItemText(hWindow, IDEXIT,   PChar(RESSTR_J_EXIT));
  end
  else
  begin
    SetDlgItemText(hWindow, IDC_BUTTON_ADDFILES,  PChar(RESSTR_E_ADDFILES));
    SetDlgItemText(hWindow, IDC_BUTTON_ADDFOLDER, PChar(RESSTR_E_ADDFOLDER));
    SetDlgItemText(hWindow, IDC_BUTTON_REMOVE,    PChar(RESSTR_E_REMOVE));
    SetWindowText(hCheckBox1, PChar(RESSTR_E_CHECK1));
    SetWindowText(hCheckBox2, PChar(RESSTR_E_CHECK2));
    SetWindowText(hCheckBox3, PChar(RESSTR_E_CHECK3));
    SetDlgItemText(hWindow, IDSTART,  PChar(RESSTR_E_START));
    SetDlgItemText(hWindow, IDABOUT,  PChar(RESSTR_E_ABOUT));
    SetDlgItemText(hWindow, IDEXIT,   PChar(RESSTR_E_EXIT));
  end;
end;

procedure SetLanguageMenu(hWindow: HWND);
var
  mii: TMenuItemInfo;
  hSysMenu : HMENU;
begin
  hSysMenu := GetSystemMenu(hWindow, LongBool(false));
  FillChar(mii, SizeOf(TMenuItemInfo), 0);
  bUseJapanese := not bUseJapanese;
  mii.cbSize := 44; // Required for Win95
  mii.fMask  := MIIM_STATE;
  if bUseJapanese then
    mii.fState := (mii.fState or MFS_CHECKED)
  else
    mii.fState := (mii.fState and (not MFS_CHECKED));
  SetMenuItemInfo(hSysMenu,
    Cardinal(IDM_CHANGELANG),
    LongBool(false),
    mii);
  SetControlText(hWindow);
end;

{==============================================================================}

procedure ShowAboutDialog(hWindow: HWND);
var
  lpRyesaptext: array[0..MAX_PATH-1] of char;
begin
  FillChar(lpRyesaptext, MAX_PATH, 0);
  lstrcat(lpRyesaptext, PChar(RyesapDescription));
  lstrcat(lpRyesaptext, PChar(CRLF));
  lstrcat(lpRyesaptext, PChar(RyesapCopy));
  lstrcat(lpRyesaptext, PChar(CRLF));
  lstrcat(lpRyesaptext, PChar(CRLF));
  lstrcat(lpRyesaptext, PChar(StripRelocVersion));
  MessageBox(hWindow, lpRyesaptext, PChar(RyesapDescription),
    MB_OK + MB_ICONINFORMATION);
end;

{==============================================================================}

procedure InitMainWindowControl(hWindow: HWND);
var
  hIcons   : HICON;
  hSysMenu : HMENU;
begin
  hIcons  := LoadIcon(0,IDI_APPLICATION);
  if hIcons <> 0 then
  begin
    SendMessage(hWindow, WM_SETICON, integer(true), LongWord(hIcons));
    DestroyIcon(hIcons);
  end;

  SetWindowText(hWindow, PChar( RyesapDescription ));

  hFileListBox := GetDlgItem(hWindow, IDC_LISTBOX);
  hCheckBox1   := GetDlgItem(hWindow, IDC_CHECK_STRIP1);
  hCheckBox2   := GetDlgItem(hWindow, IDC_CHECK_STRIP2);
  hCheckBox3   := GetDlgItem(hWindow, IDC_CHECK_STRIP3);

  SendMessage(hCheckBox1, BM_SETCHECK, BST_UNCHECKED, 0);
  SendMessage(hCheckBox1, BM_SETCHECK, BST_CHECKED,   0);
  SendMessage(hCheckBox1, BM_SETCHECK, BST_UNCHECKED, 0);

  hSysMenu := GetSystemMenu(hWindow, LongBool(false));
  InsertMenu(hSysMenu, 0, MF_BYPOSITION or MF_SEPARATOR, 0, nil);
  InsertMenu(hSysMenu, 0,
     MF_BYPOSITION or MF_STRING,
     IDM_CHANGELANG,
     PChar(RESSTR_CHANGELANG));

  SetControlText(hWindow);
  SetPosition(hWindow);

end;

{==============================================================================}

// callback for main window
function MainWndProc(
  hWindow: HWND;
  uMsg: UINT;
  wParam: WPARAM;
  lParam: LPARAM): LRESULT; stdcall;
var
  nParamStr: integer;
  wTargetID: Word;
begin
  result := LRESULT(true);
  case uMsg of
    WM_INITDIALOG:
    begin
      InitMainWindowControl(hWindow);
      if integer(lParam) > 0 then
      begin
        for nParamStr:=1 to integer(lParam) do
        begin
          if ((ParamStr(nParamStr)) <> '/j') and ((ParamStr(nParamStr)) <> '/J') then
          AddStringToListBox(hFileListBox, PChar(ParamStr(nParamStr)));
        end;
      end;
    end;
    WM_CLOSE:
      begin
        if hProgressWindow <> 0 then
          EndDialog(hProgressWindow, 0);
        EndDialog(hWindow, 0);
      end;
    WM_DESTROY:
      PostQuitMessage(0);
    WM_DROPFILES:
      CheckDroppedFiles(THandle(wParam));
    WM_SYSCOMMAND:
      case LoWord(wParam) of
        IDM_CHANGELANG:
        begin
          SetLanguageMenu(hWindow);
        end;
      else
        Result := LRESULT(false);
      end;
    WM_COMMAND:
      case HiWord(wParam) of
        BN_CLICKED:
        begin
          wTargetID := LoWord(wParam);
          case wTargetID of
            IDOK,
            IDCANCEL,
            IDEXIT:
              SendMessage(hWindow, WM_CLOSE, 0, 0);
            IDC_BUTTON_ADDFILES  : GetOpenFileDlg(hWindow);
            IDC_BUTTON_ADDFOLDER : ShowSelectFolderDialog(hWindow);
            IDC_BUTTON_REMOVE    : RemoveFiles(hWindow);
            IDABOUT: ShowAboutDialog(hWindow);
            IDSTART: ProcessFiles(hWindow);
          end;
        end;
      end;
  else
    Result := LRESULT(false);
  end;
end;

{==============================================================================}

// main window routine
function WinMain(HThisInstance, hPrevInstance: Cardinal;
  lpCmdLine: LPCSTR; nCmdShow: integer): integer; stdcall;
var
  nParamCount: integer;
begin
  Result := 0;

  if FindWindow(nil, PChar(RyesapDescription)) <> 0 then
    Exit;

  if ParamCount > 0 then
  begin
    for nParamCount:=1 to ParamCount do
    begin
      if (ParamStr(nParamCount) = '/j') or
         (ParamStr(nParamCount) = '/J') then
      begin
        bUseJapanese := true;
      end;
    end;
  end;

  hMainWindow := DialogBoxParam(
    HInstance,
    MAKEINTRESOURCE(IDD_DIALOG),
    0,
    @MainWndProc,
    ParamCount);

end;

{==============================================================================}

// entry point
begin
  WinMain(HInstance, 0, nil, SW_HIDE);
end.
